/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBGL)

#include "JSOESTextureHalfFloat.h"

#include "OESTextureHalfFloat.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table for prototype */

static const HashTableValue JSOESTextureHalfFloatPrototypeTableValues[] =
{
    { "HALF_FLOAT_OES", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsOESTextureHalfFloatHALF_FLOAT_OES), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSOESTextureHalfFloatPrototypeTable = { 2, 1, true, JSOESTextureHalfFloatPrototypeTableValues, 0 };
const ClassInfo JSOESTextureHalfFloatPrototype::s_info = { "OESTextureHalfFloatPrototype", &Base::s_info, &JSOESTextureHalfFloatPrototypeTable, 0, CREATE_METHOD_TABLE(JSOESTextureHalfFloatPrototype) };

JSObject* JSOESTextureHalfFloatPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSOESTextureHalfFloat>(vm, globalObject);
}

bool JSOESTextureHalfFloatPrototype::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSOESTextureHalfFloatPrototype* thisObject = jsCast<JSOESTextureHalfFloatPrototype*>(object);
    return getStaticValueSlot<JSOESTextureHalfFloatPrototype, JSObject>(exec, JSOESTextureHalfFloatPrototypeTable, thisObject, propertyName, slot);
}

const ClassInfo JSOESTextureHalfFloat::s_info = { "OESTextureHalfFloat", &Base::s_info, 0, 0 , CREATE_METHOD_TABLE(JSOESTextureHalfFloat) };

JSOESTextureHalfFloat::JSOESTextureHalfFloat(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<OESTextureHalfFloat> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSOESTextureHalfFloat::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSOESTextureHalfFloat::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSOESTextureHalfFloatPrototype::create(vm, globalObject, JSOESTextureHalfFloatPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSOESTextureHalfFloat::destroy(JSC::JSCell* cell)
{
    JSOESTextureHalfFloat* thisObject = static_cast<JSOESTextureHalfFloat*>(cell);
    thisObject->JSOESTextureHalfFloat::~JSOESTextureHalfFloat();
}

JSOESTextureHalfFloat::~JSOESTextureHalfFloat()
{
    releaseImplIfNotNull();
}

// Constant getters

EncodedJSValue jsOESTextureHalfFloatHALF_FLOAT_OES(ExecState* exec, EncodedJSValue, EncodedJSValue, PropertyName)
{
    UNUSED_PARAM(exec);
    return JSValue::encode(jsNumber(static_cast<int>(0x8D61)));
}

static inline bool isObservable(JSOESTextureHalfFloat* jsOESTextureHalfFloat)
{
    if (jsOESTextureHalfFloat->hasCustomProperties())
        return true;
    return false;
}

bool JSOESTextureHalfFloatOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    JSOESTextureHalfFloat* jsOESTextureHalfFloat = jsCast<JSOESTextureHalfFloat*>(handle.get().asCell());
    if (!isObservable(jsOESTextureHalfFloat))
        return false;
    WebGLRenderingContext* root = jsOESTextureHalfFloat->impl().context();
    return visitor.containsOpaqueRoot(root);
}

void JSOESTextureHalfFloatOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSOESTextureHalfFloat* jsOESTextureHalfFloat = jsCast<JSOESTextureHalfFloat*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsOESTextureHalfFloat->impl(), jsOESTextureHalfFloat);
    jsOESTextureHalfFloat->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7OESTextureHalfFloat@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore19OESTextureHalfFloatE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, OESTextureHalfFloat* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSOESTextureHalfFloat>(exec, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7OESTextureHalfFloat@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore19OESTextureHalfFloatE[2];
#if COMPILER(CLANG)
    // If this fails OESTextureHalfFloat does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(OESTextureHalfFloat), OESTextureHalfFloat_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // OESTextureHalfFloat has subclasses. If OESTextureHalfFloat has subclasses that get passed
    // to toJS() we currently require OESTextureHalfFloat you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    ReportMemoryCost<OESTextureHalfFloat>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSOESTextureHalfFloat>(exec, globalObject, impl);
}

OESTextureHalfFloat* toOESTextureHalfFloat(JSC::JSValue value)
{
    return value.inherits(JSOESTextureHalfFloat::info()) ? &jsCast<JSOESTextureHalfFloat*>(value)->impl() : 0;
}

}

#endif // ENABLE(WEBGL)
